#ifndef DGX_TEXTBOX_2D_H
#define DGX_TEXTBOX_2D_H

/*
 * Fonts must be formatted in such a way that:
 *	-every character has the same dimensions
 *	-10 characters per row, 10 rows in total
 *	-characters correspond with ASCII codes starting with '!' (33) to '~' (126)
 *	-the entire texture must be less than or equal to 256x256px in size
 *
 * otherwise, it may not work properly :p
 */

#include <engine/psx.h>

#define TEXTBOX_MESSAGE_LIMIT	256

/* IMPORTANT: the x, y members are interpreted as 4096-format integers. */
struct TextBox
{
	int		x, y;			/* top-left corner of textbox on-screen */
	unsigned char	u, v;			/* top-left corner of font texture in texture */
	unsigned short	max_x;			/* max characters horizontally on-screen */
	unsigned char	char_w, char_h;		/* width and height of each character */

	struct
	{
		char		message[TEXTBOX_MESSAGE_LIMIT];
		SPRT		display[TEXTBOX_MESSAGE_LIMIT];
	}data;

	DR_TPAGE	dr_tpage;		/* tpage for SPRTs */

	/* DEBUG */
	int		is_debug;
	LINE_F2		debug_left;
	LINE_F4		debug_right;
};

#endif

